import { AnchorProvider, Program } from "@coral-xyz/anchor";
import { Wallet } from "@coral-xyz/anchor/dist/cjs/provider";
import { ConfirmOptions, Connection } from "@solana/web3.js";
import { StakingType } from "./types";
import { AccountFetcher } from "./fetcher";
import { Methods } from "./methods";
/**
 * @category Core
 */
export declare class Context {
    readonly connection: Connection;
    readonly wallet: Wallet;
    readonly opts: ConfirmOptions;
    readonly program: Program<StakingType>;
    readonly provider: AnchorProvider;
    readonly fetcher: AccountFetcher;
    readonly methods: Methods;
    static from(connection: Connection, wallet: Wallet, fetcher?: AccountFetcher, opts?: ConfirmOptions): Context;
    static fromWorkspace(provider: AnchorProvider, program: Program, fetcher?: AccountFetcher, opts?: ConfirmOptions): Context;
    static withProvider(provider: AnchorProvider, fetcher?: AccountFetcher, opts?: ConfirmOptions): Context;
    constructor(provider: AnchorProvider, wallet: Wallet, program: Program, fetcher: AccountFetcher, opts: ConfirmOptions);
}
