"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParsableLockupStakingAccount = exports.ParsableLockupVault = exports.ParsableFlexibleVault = exports.ParsableConfig = void 0;
const types_1 = require("../types");
/**
 * Class decorator to define an interface with static methods
 * Reference: https://github.com/Microsoft/TypeScript/issues/13462#issuecomment-295685298
 */
function staticImplements() {
    return (constructor) => {
        constructor;
    };
}
function parseAnchorAccount(accountName, data) {
    const discriminator = types_1.accountsCoder.accountDiscriminator(accountName);
    if (discriminator.compare(data.subarray(0, 8))) {
        console.error("incorrect account name during parsing");
        return null;
    }
    try {
        return types_1.accountsCoder.decode(accountName, data);
    }
    catch (_e) {
        console.error("unknown account name during parsing");
        return null;
    }
}
// YOUR ACCOUNTS
let ParsableConfig = class ParsableConfig {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.Config, data);
        }
        catch (e) {
            console.error(`error while parsing Config: ${e}`);
            return null;
        }
    }
};
exports.ParsableConfig = ParsableConfig;
exports.ParsableConfig = ParsableConfig = __decorate([
    staticImplements()
], ParsableConfig);
let ParsableFlexibleVault = class ParsableFlexibleVault {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.FlexibleVault, data);
        }
        catch (e) {
            console.error(`error while parsing Flexible Vault: ${e}`);
            return null;
        }
    }
};
exports.ParsableFlexibleVault = ParsableFlexibleVault;
exports.ParsableFlexibleVault = ParsableFlexibleVault = __decorate([
    staticImplements()
], ParsableFlexibleVault);
let ParsableLockupVault = class ParsableLockupVault {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.LockupVault, data);
        }
        catch (e) {
            console.error(`error while parsing Lockup Vault: ${e}`);
            return null;
        }
    }
};
exports.ParsableLockupVault = ParsableLockupVault;
exports.ParsableLockupVault = ParsableLockupVault = __decorate([
    staticImplements()
], ParsableLockupVault);
let ParsableLockupStakingAccount = class ParsableLockupStakingAccount {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.LockupStakingAccount, data);
        }
        catch (e) {
            console.error(`error while parsing Lockup Staking Account: ${e}`);
            return null;
        }
    }
};
exports.ParsableLockupStakingAccount = ParsableLockupStakingAccount;
exports.ParsableLockupStakingAccount = ParsableLockupStakingAccount = __decorate([
    staticImplements()
], ParsableLockupStakingAccount);
