import { PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface PDAInfo {
    key: PublicKey;
    bump: number;
}
export declare class PDA {
    readonly programId: PublicKey;
    constructor(programId: PublicKey);
    config: () => PDAInfo;
    flexibleStakingAccount: (user: PublicKey) => PDAInfo;
    flexibleVault: () => PDAInfo;
    user: (user: PublicKey) => PDAInfo;
    lockupStakingAccount: (user: PublicKey, index: BN, vaultIndex: BN) => PDAInfo;
    lockupVault: (index: BN) => PDAInfo;
    withdrawPosition: (user: PublicKey, index: BN) => PDAInfo;
}
