import { PublicKey, TransactionInstruction } from "@solana/web3.js";
import { Program } from "@coral-xyz/anchor";
import { Staking } from "../artifacts/staking";

export type InitUserParams = {
  accounts: {
    user: PublicKey;
  };
  inputs: {
    bump: number;
  };
};

export async function initUser(
  program: Program<Staking>,
  params: InitUserParams,
): Promise<TransactionInstruction> {
  const { accounts, inputs } = params;

  const ix = await program.methods
    .initializeUser(inputs.bump)
    .accounts({
      ...accounts,
    })
    .instruction();

  return ix
}
