import { Program } from "@coral-xyz/anchor";
import { PublicKey, TransactionInstruction } from "@solana/web3.js";
import { Staking } from "../artifacts/staking";

export type UpdateAdminParams = {
  inputs: {
    newAdmin: PublicKey;
  };
};

export async function updateAdmin(
  program: Program<Staking>,
  params: UpdateAdminParams,
): Promise<TransactionInstruction> {
  const { inputs } = params;

  const ix = await program.methods
    .updateAdmin(
      inputs.newAdmin,
    )
    .instruction();

  return ix;
}
