import { BN, Program } from "@coral-xyz/anchor";
import { TransactionInstruction } from "@solana/web3.js";
import { Staking } from "../artifacts/staking";

export type UpdateFlexibleVaultParams = {
  inputs: {
    rewardRate: BN;
    withdrawalDelayTime: BN;
  };
};

export async function updateFlexibleVault(
  program: Program<Staking>,
  params: UpdateFlexibleVaultParams,
): Promise<TransactionInstruction> {
  const { inputs } = params;

  const ix = await program.methods
    .updateFlexibleVault(
      inputs.rewardRate,
      inputs.withdrawalDelayTime,
    )
    .instruction();

  return ix;
}
