import { BN, Program } from "@coral-xyz/anchor";
import { TransactionInstruction } from "@solana/web3.js";
import { Staking } from "../artifacts/staking";

export type UpdateLockupVaultParams = {
  inputs: {
    index: number;
    apy: number;
    lockupDuration: BN;
    minStakeAmount: BN;
  };
};

export async function updateLockupVault(
  program: Program<Staking>,
  params: UpdateLockupVaultParams,
): Promise<TransactionInstruction> {
  const { inputs } = params;

  const ix = await program.methods
    .updateLockupVault(
      inputs.index,
      inputs.apy,
      inputs.lockupDuration,
      inputs.minStakeAmount,
    )
    .instruction();

  return ix;
}
