import { DISCRIMINATOR_SIZE, I64_SIZE, PUBKEY_SIZE, U32_SIZE, U64_SIZE, U8_SIZE, U16_SIZE } from "./constants";

export const getWithdrawPositionUserOffset = (): number => {
  return DISCRIMINATOR_SIZE + // Discriminator
    U8_SIZE + // bump
    U32_SIZE; // index
};

export const getWithdrawPositionClaimedOffset = (): number => {
  return DISCRIMINATOR_SIZE + // Discriminator
    U8_SIZE + // bump
    U32_SIZE + // index
    PUBKEY_SIZE + // user
    U64_SIZE + // amount
    I64_SIZE; // start_delay_time
};

export const getLockupStakingAccountOwnerOffset = (): number => {
  return DISCRIMINATOR_SIZE + // Discriminator
    U8_SIZE + // bump
    U32_SIZE; // index
};

export const getLockupStakingAccountUnlockedOffset = (): number => {
  return DISCRIMINATOR_SIZE + // Discriminator
    U8_SIZE + // bump
    U32_SIZE + // index
    PUBKEY_SIZE + // owner
    PUBKEY_SIZE + // lockup_vault
    U16_SIZE + // committed_apy
    U64_SIZE + // locked_amount
    I64_SIZE; // locked_at
};
